﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Serialization;
using LinqExtender.Interface;
using LinqExtender.Attribute;

namespace LinqToTwitter.Core
{
    public enum Timeline
    {
        Friends,
        User
    }
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlRootAttribute(ElementName = "status", Namespace = "", IsNullable = false)]
    public class Twit : IQueryObject
    {
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute(ElementName = "id", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        [UniqueIdentifier]
        public string Id { get; set; }
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute(ElementName = "text", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        public string Text { get; set; }
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute("created_at", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]

        public string LastUpdated { get; set; }
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute("source", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        public string Source { get; set; }
        /// <remarks/>
        [System.Xml.Serialization.XmlElement("user", Form = System.Xml.Schema.XmlSchemaForm.Unqualified)]
        public User User { get; set; }
    
        public string Username { get; set; }
        public string Password { get; set; }
        public Timeline Timeline { get; set; }

        /// <summary>
        /// User's screen name. <c>User.ScreenName</c>
        /// </summary>
        [Ignore]
        public string ScreenName
        {
            get
            {
                return User.ScreenName;
            }
        }
       
    }
}